Attribute VB_Name = "LAY"
'    .
Public PathOpen$, PathSave$ '    
Public SourceFile$ '  

'LAY-:
Public objIndex() As Long   '  
Public grpIndex() As Long   '    /  
Public Groups() As Long     'c   
Public Xcorp() As Long, Ycorp() As Long '  ( ), 
Public Nobj '  
Public Ngrp ' 
Public TopLayer As Boolean, BotLayer As Boolean, B1Layer As Boolean, B2Layer As Boolean '   
Public BoundLine '   



Public Function ReadLng(LayFile$, ByRef adr) As Long
'        LayFile$.
'   4
  a$ = ""
  For i = adr + 1 To adr + 4
    a$ = Right$("0" + Hex$(Asc(Mid$(LayFile$, i, 1))), 2) + a$
  Next i
  ReadLng = Val("&H" + a$)
  adr = i - 1
End Function

Public Function ReadFlt(LayFile$, ByRef adr) As Long
'          LayFile$.
'   4
  a$ = ""
  For i = adr + 1 To adr + 3
    b = Asc(Mid$(LayFile$, i, 1))
    If i = adr + 3 Then b = b And 127
    a$ = Right$("0" + Hex$(b), 2) + a$
  Next i
  b = Val("&H" + a$)
  b = (b / 8388608) + 1
  n = Asc(Mid$(LayFile$, adr + 4, 1))
  If n > 127 Then b = -b
  n = (n And 127) * 2
  If Asc(Mid$(LayFile$, adr + 3, 1)) > 127 Then n = n + 1
  n = n - 127
  If n > 0 Then
    For i = 1 To n
      b = b * 2
    Next i
  End If
  If n < 0 Then
    For i = 1 To (-n)
      b = b / 2
    Next i
  End If
  ReadFlt = b
  adr = adr + 4
End Function

Private Function ReadName(LayFile$, ByRef adr) As String
'       LayFile$.
'    
  If Asc(Mid$(LayFile$, (adr - 80), 1)) = 7 Then adr = adr - 4 ' "" 
  namelong = ReadLng(LayFile$, adr) 'adr 
  ReadName = Mid$(LayFile$, adr + 1, namelong)
  adr = adr + namelong
End Function

Private Function Format2(n) As String
'          
  i = CLng(n * 100) / 100
  If i < 0 And i > -1 Then a$ = "-0" + Trim(Str$(-i)) Else a$ = Trim(Str$(i))
  i = InStr(a$, ".")
  If i = 0 Then a$ = a$ + ".00" Else a$ = Left$(a$ + "00", i + 2)
  If i = 1 Then a$ = "0" + a$
  Format2 = a$
End Function

Private Function objCoords(LayFile$, objadr, offsX, offsY) As String
'    
'   LayFile$,   .
'      .
'   objadr.
'offsX, offsY - (   ,  ).
  Dim c(3)
  objCoords = ""
  Select Case Asc(Mid$(LayFile$, (objadr + 1), 1))
    Case 2 'PIN/VIA
      Select Case Asc(Mid$(LayFile$, (objadr + 24), 1))
        Case 1 '
          adr = objadr + 1
          objCoords = objCoords + Format2((ReadFlt(LayFile$, adr) + offsX) / 100)
          objCoords = objCoords + " " + Format2((ReadFlt(LayFile$, adr) + offsY) / 100)
        Case 4, 7 '   
          adr = objadr + 9
          r1 = ReadFlt(LayFile$, adr) * 1.4142135623731
          adr = objadr + 81
          n = ReadLng(LayFile$, adr): adr = adr + n
          n = ReadLng(LayFile$, adr): adr = adr + (n * 4) + 4
          For i = 0 To 3
            c(i) = ReadFlt(LayFile$, adr)
          Next i
          i = c(2) - c(0): n = c(3) - c(1)
          If i = 0 Then
            If n < 0 Then
              n = -1.5707963267949
            Else
              n = 1.5707963267949
            End If
          Else
            n = Atn(n / i)
            If i < 0 Then
              n = n + 3.14159265358979
            End If
          End If
          i = 0.785398163397448
          objCoords = objCoords + Format2((offsX + c(0) - r1 * Cos(i - n)) / 100) + " "
          objCoords = objCoords + Format2((offsY + c(1) + r1 * Sin(i - n)) / 100) + " "
          objCoords = objCoords + Format2((offsX + c(2) + r1 * Cos(i + n)) / 100) + " "
          objCoords = objCoords + Format2((offsY + c(3) + r1 * Sin(i + n)) / 100) + " "
          objCoords = objCoords + Format2((offsX + c(2) + r1 * Cos(i - n)) / 100) + " "
          objCoords = objCoords + Format2((offsY + c(3) - r1 * Sin(i - n)) / 100) + " "
          objCoords = objCoords + Format2((offsX + c(0) - r1 * Cos(i + n)) / 100) + " "
          objCoords = objCoords + Format2((offsY + c(1) - r1 * Sin(i + n)) / 100)
        Case Else
          adr = objadr + 81
          n = ReadLng(LayFile$, adr): adr = adr + n
          n = ReadLng(LayFile$, adr): adr = adr + n * 4
          n = ReadLng(LayFile$, adr)
          For i = 1 To n
            objCoords = objCoords + " " + Format2((ReadFlt(LayFile$, adr) + offsX) / 100)
            objCoords = objCoords + " " + Format2((ReadFlt(LayFile$, adr) + offsY) / 100)
            objCoords = Trim(objCoords)
          Next i
      End Select
    Case 5 '/
      n = 57.2957795130823
      adr = objadr + 1
      c(0) = ReadFlt(LayFile$, adr) 'X, . 
      c(1) = ReadFlt(LayFile$, adr) 'Y
      adr = objadr + 17
      c(3) = ReadLng(LayFile$, adr) / n '  
      adr = objadr + 31
      c(2) = ReadLng(LayFile$, adr) / n '  
      adr = objadr + 9
      r1 = ReadFlt(LayFile$, adr)
      r1 = r1 + ReadFlt(LayFile$, adr)
      r1 = r1 / 2 '
      If c(2) >= c(3) Then c(3) = c(3) + 6.28318530718
      For i = c(2) To c(3) + 0.000000000002 Step (c(3) - c(2)) / (4 + CLng(r1 / 50))
        '   (50 -  )
        If Abs(i) > 12 Then Exit For
        objCoords = objCoords + Format2((c(0) + r1 * Cos(i) + offsX) / 100) + " "
        objCoords = objCoords + Format2((c(1) + r1 * Sin(i) + offsY) / 100) + " "
      Next i
      objCoords = Trim(objCoords)
    Case 7
    Case Else
      adr = objadr + 81
      n = ReadLng(LayFile$, adr): adr = adr + n
      n = ReadLng(LayFile$, adr): adr = adr + n * 4
      n = ReadLng(LayFile$, adr)
      For i = 1 To n
        objCoords = objCoords + " " + Format2((ReadFlt(LayFile$, adr) + offsX) / 100)
        objCoords = objCoords + " " + Format2((ReadFlt(LayFile$, adr) + offsY) / 100)
        objCoords = Trim(objCoords)
      Next i
  End Select
End Function

Public Sub midCoord(LayFile$, objadr, ByRef midX, ByRef midY)
'       LayFile$
'   ,
'    midX  midY.
'   objadr.
  midX = 0: midY = 0
  n = Asc(Mid$(LayFile$, (objadr + 1), 1))
  If n = 5 Or n = 7 Or (n = 2 And Asc(Mid$(LayFile$, (objadr + 24), 1)) = 1) Then
    adr = objadr + 1
    midX = ReadFlt(LayFile$, adr)
    midY = ReadFlt(LayFile$, adr)
    Exit Sub
  End If
  adr = objadr + 81
  n = ReadLng(LayFile$, adr): adr = adr + n
  n = ReadLng(LayFile$, adr): adr = adr + n * 4
  n = ReadLng(LayFile$, adr)
  For i = 1 To n
    midX = midX + ReadFlt(LayFile$, adr)
    midY = midY + ReadFlt(LayFile$, adr)
  Next i
  midX = midX / n: midY = midY / n
End Sub

Private Function objCoord1(LayFile$, objadr, offsX, offsY) As String
'    ,
'  .
'      .
'   objadr.
'offsX, offsY - (   ).
  Call midCoord(LayFile$, objadr, midX, midY)
  objCoord1 = Format2((midX + offsX) / 100) + " " + Format2((midY + offsY) / 100)
End Function

Private Function objName(LayFile$, objadr) As String
'    
'    LayFile$.
'   .
'      .
'   objadr.
  objName = ""
  adr = objadr + 81: a$ = ReadName(LayFile$, adr)
  If a$ = "" Then Exit Function
  For i = 1 To Len(a$)
    b$ = Mid$(a$, i, 1)
    Select Case b$
      Case " ": objName = objName + "_"
      Case "(": objName = objName + "{"
      Case ")": objName = objName + "}"
      Case "*": objName = objName + "~"
      Case ";": objName = objName + ":"
      Case Chr$(34): objName = objName + Chr$(96)
      Case Else: objName = objName + b$
    End Select
  Next i
End Function

Private Function objLayer(LayFile$, objadr) As String
'    
'      LayFile$.
'     ,   
'   ,    signal
'   objadr.
  objLayer = ""
  j = Asc(Mid$(LayFile$, (objadr + 23), 1)) ' 
  If j = 1 Then objLayer = Chr$(34) + "1#Top" + Chr$(34)
  If j = 3 Then objLayer = Chr$(34) + "2#Bottom" + Chr$(34)
  If Asc(Mid$(LayFile$, (objadr + 1), 1)) = 2 And Asc(Mid$(LayFile$, (objadr + 58), 1)) = 1 Then objLayer = "signal"
End Function

Private Function smdID(LayFile$, objadr) As String
'   SMD-,   .
'     .
'   objadr.
  smdID = ""
  If Asc(Mid$(LayFile$, (objadr + 1), 1)) = 8 Then
    j = Asc(Mid$(LayFile$, (objadr + 23), 1)) '  
    adr = objadr + 81
    n = ReadLng(LayFile$, adr): adr = adr + n
    n = ReadLng(LayFile$, adr): adr = adr + (n * 4) + 4
    n = ReadFlt(LayFile$, adr)
    n1 = ReadFlt(LayFile$, adr): adr = adr + 4
    smdID = HexM(ReadFlt(LayFile$, adr) - n1, j)
    smdID = smdID + HexM(ReadFlt(LayFile$, adr) - n, j)
    smdID = smdID + HexM(n1 - ReadFlt(LayFile$, adr), j)
    If j > 1 Then smdID = smdID + "W"
  End If
End Function
Private Function HexM(n, ByRef l) As String
'   hex-
'  
  If n < 0 Then
    If l = 1 Then
      HexM = "M" + Hex$(-n)
    Else
      HexM = "W" + Hex$(-n)
      l = 0
    End If
  Else
    HexM = Hex$(n)
  End If
End Function

Private Function Tree(ByRef LayFile$, ByRef objIndexArray As Variant, objNum, netListadr, netNum, ByRef netArray As Variant) As Boolean
'  .

'LayFile$ -  LAY-
'objIndexArray -   (   )
'objNum  
'netListadr -   
'netNum -  
'netArray -    (  )

'      netNum   True.
' False,        
  Tree = False
  If netArray(objNum) >= 0 Then Exit Function '      
  adr = netListadr
  For i = 0 To objNum '   
    n = Asc(Mid$(LayFile$, objIndexArray(i) + 1, 1)) ' 
    If n = 2 Or n = 8 Then                                '  
      n = ReadLng(LayFile$, adr) '  
      adr = adr + n * 4
    Else
      n = 0
    End If
  Next i
  If n = 0 Then Exit Function
  adr = adr - (n * 4)
  netArray(objNum) = netNum '    
  For i = 1 To n
    '       
    Tree = Tree(LayFile$, objIndexArray, ReadLng(LayFile$, adr), netListadr, netNum, netArray)
  Next i
  Tree = True
End Function

Private Function objSearch(LayFile$, coordX, coordY, layer) As Long
'         ( ).
'     ,  -1
'    .
  objSearch = -1
  If layer < 1 Or layer = 2 Or layer = 4 Or layer > 6 Then Exit Function
  For i = 0 To Nobj - 1
    l = Asc(Mid$(LayFile$, objIndex(i) + 23, 1))
    Select Case Asc(Mid$(LayFile$, objIndex(i) + 1, 1)) ' 
      Case 2
        If Asc(Mid$(LayFile$, objIndex(i) + 40, 1)) = 1 Or l = layer Then
          adr = objIndex(i) + 1
          objX = ReadFlt(LayFile$, adr)
          objY = ReadFlt(LayFile$, adr)
          d = ReadFlt(LayFile$, adr) ' ,  
          If Abs(objX - coordX) <= d And Abs(objY - coordY) <= d Then
            objSearch = i
            Exit Function
          End If
        End If
      Case 8
        If l = layer Then
          objX = 0: objY = 0
          adr = objIndex(i) + 81
          n = ReadLng(LayFile$, adr): adr = adr + n
          n = ReadLng(LayFile$, adr): adr = adr + n * 4
          n = ReadLng(LayFile$, adr)
          For j = 1 To n
            objX = objX + Sgn(coordX - ReadFlt(LayFile$, adr))
            objY = objY + Sgn(coordY - ReadFlt(LayFile$, adr))
          Next j
          If Abs(objX) < n And Abs(objY) < n Then
            '(   )
            objSearch = i
            Exit Function
          End If
        End If
    End Select
  Next i
End Function

Public Sub OpenLAY(PathLay$, ByRef LayFile$)
'   LAY-.
' - PathLay$,    lay-
'LayFile$ - ,   
  Dim q As String '
  q = Chr$(34)
  Form1.Label1.Caption = "  ..."
  DoEvents

  On Error GoTo LayOpenError
  filenum = FreeFile: Open PathLay$ For Binary As #filenum  'For Binary -     ,  
  LayFile$ = Input$(LOF(filenum), filenum)
  On Error GoTo 0
  Close filenum: filenum = 0
  Form1.Label1.Caption = ""
  ' LayFile$    .


' -------       lay  --------
  
  adr = &H21A: Nobj = ReadLng(LayFile$, adr)  'Nobj -    
  If Nobj = 0 Then
    MsgBox "   ." + vbCrLf + " .", vbCritical, "Blank PCB"
    End
  End If
  ReDim objIndex(Nobj)
  ReDim grpIndex(Nobj)
  TopLayer = False: BotLayer = False: B1 = False: B2 = False
  Form1.Label1.Caption = "   LAY"
  '  
  ' adr       &H21E
  For i = 0 To Nobj - 1
    objIndex(i) = adr
    k = Asc(Mid$(LayFile$, (adr + 1), 1)) 'k - 
    Select Case (Asc(Mid$(LayFile$, (adr + 23), 1))) ' 
      Case 1: TopLayer = True
      Case 3: BotLayer = True
      Case 5: B1Layer = True
      Case 6: B2Layer = True
      Case 7: If k = 6 Then BoundLine = adr ' 
    End Select
    If k = 7 Then      ' 
      adr = adr + 77                 '   
      j = ReadLng(LayFile$, adr): adr = adr + j    '  
      j = ReadLng(LayFile$, adr): adr = adr + j    '   
      grpIndex(i) = adr
      j = ReadLng(LayFile$, adr): adr = adr + j * 4 '   
      k = ReadLng(LayFile$, adr) ' 
      For j = 1 To k
        adr = adr + 77
        k1 = ReadLng(LayFile$, adr) '   
        adr = adr + k1 * 8 '   
      Next j
    Else
      adr = adr + 81                 '  
      j = ReadLng(LayFile$, adr): adr = adr + j    '   
      grpIndex(i) = adr
      j = ReadLng(LayFile$, adr): adr = adr + j * 4 '   
      If k <> 5 Then  '   
        j = ReadLng(LayFile$, adr): adr = adr + j * 8 '   
      End If
    End If
  Next i
  grpIndex(Nobj) = adr '  -    

  If (TopLayer Or BotLayer) = False Then
    MsgBox " M1  M2 ." + vbCrLf + " .", vbCritical, "Quit"
    End
  End If
  DoEvents

  ' 
  Ngrp = 0
  For i = 0 To Nobj - 1
    adr = grpIndex(i)
    k = ReadLng(LayFile$, adr)
    If k > 0 Then
      For j = 1 To k
        n = ReadLng(LayFile$, adr)
        If n > Ngrp Then Ngrp = n
      Next j
    End If
  Next i
  DoEvents
  ReDim Groups(Ngrp + 1, Nobj)
  '   
  For i = 0 To Nobj - 1
    k = Asc(Mid$(LayFile$, (objIndex(i) + 1), 1)) ' 
    adr = grpIndex(i): n = ReadLng(LayFile$, adr)
    For j = 1 To n
      k1 = ReadLng(LayFile$, adr)
      Groups(k1, i) = k '  k    
    Next j
  Next i
  DoEvents

'      lay:
' Nobj -   
' Ngrp - 
' objIndex -   
' grpIndex -   
' Groups -   
' TopLayer, BotLayer, B1Layer, B2Layer -    
' BoundLine -     (  0)
' grpIndex(Nobj) -    

' .
  '    
  For i = 1 To Ngrp
    Form1.Label2.Caption = i
    n = 0
    For j = 0 To Nobj - 1
      If Groups(i, j) > 0 Then n = n + 1
    Next j
    Groups(i, Nobj) = n
  Next i
  DoEvents
  k = 1 ' 
  Do
    '  
    n = 0: k1 = 0
    For i = 1 To Ngrp
      If Groups(i, Nobj) > n Then
        n = Groups(i, Nobj)
        k1 = i
      End If
    Next i
    DoEvents
    'k1 -  
    If k1 > 0 Then
      For i = 0 To Nobj - 1
        If Groups(k1, i) > 0 Then
          If Groups(k1, i) = 2 Or Groups(k1, i) = 8 Then Groups(0, k) = k1 '   PAD  SMD
          For j = 1 To Ngrp
            If Groups(j, i) > 0 Then Groups(j, Nobj) = 0 '    ,    
          Next j
        End If
      Next i
      If Groups(0, k) > 0 Then k = k + 1
    End If
  Loop Until n = 0
  Groups(0, 0) = k - 1
  ReDim Xcorp(k)
  ReDim Ycorp(k)
  DoEvents
' Groups(0, k)   ,  . k -  ,   1
'Groups(0, 0)   .

  ' 
  If Groups(0, 0) > 0 Then
    For i = 1 To Groups(0, 0)
      n = 0
      For j = 0 To Nobj - 1
        If objLayer(LayFile$, objIndex(j)) <> "" And (Groups(Groups(0, i), j) = 2 Or Groups(Groups(0, i), j) = 8) Then
          Call midCoord(LayFile$, objIndex(j), k, k1)
          Xcorp(i) = Xcorp(i) + k: Ycorp(i) = Ycorp(i) + k1
          n = n + 1
        End If
      Next j
      '       
      Xcorp(i) = CLng(-Xcorp(i) / n): Ycorp(i) = CLng(-Ycorp(i) / n)
    Next i
  End If
' -Xcorp(k), -Ycorp(k)   k (   )

 Form1.Label1.Caption = ""
 Form1.Label2.Caption = ""
 DoEvents
Exit Sub

LayOpenError:
  MsgBox PathLay$, vbCritical, "   "
  Resume LayOpenError1
LayOpenError1:
On Error GoTo 0
Close
End
End Sub


Public Function DSNfile$(LayFile$)
'========   dsn- ===============
  
  Dim MultiLayer As Boolean ' 
  Dim objCorpName() As String   '   
  Dim q As String '
  
  q = Chr$(34)
  ReDim objCorpName(Nobj)
'  For i = 0 To Nobj: objCorpName(i) = q + "ERR" + Trim(Str$(i)) + q: Next i '()
  Form1.Label1.Caption = " " + vbCrLf
  DoEvents

  adr = &H2B
  PCBX = ReadLng(LayFile$, adr) / 100
  PCBY = ReadLng(LayFile$, adr) / -100
  If Asc(Mid$(LayFile$, &H21A, 1)) = 1 Then MultiLayer = True

  DSNfile$ = "(PCB " + q + Replace(Trim(Mid$(LayFile$, &HA, Asc(Mid$(LayFile$, &H9, 1)))), " ", "_") + "_" + q + vbCrLf
  DSNfile$ = DSNfile$ + "  (parser" + vbCrLf
  DSNfile$ = DSNfile$ + "    (constant laysourcefile " + q + Replace(PathOpen$, " ", ">") + q + ")" + vbCrLf
  DSNfile$ = DSNfile$ + "  )" + vbCrLf
  DSNfile$ = DSNfile$ + "  (resolution mm 100)" + vbCrLf
  DSNfile$ = DSNfile$ + "  (unit mm)" + vbCrLf
  DSNfile$ = DSNfile$ + "  (structure" + vbCrLf

  If MultiLayer Or TopLayer Then
    DSNfile$ = DSNfile$ + "    (layer " + q + "1#Top" + q + " (type signal))" + vbCrLf
  Else
    DSNfile$ = DSNfile$ + "    (layer " + q + "1#Top" + q + " (type jumper))" + vbCrLf
  End If
  If MultiLayer Or BotLayer Then
    DSNfile$ = DSNfile$ + "    (layer " + q + "2#Bottom" + q + " (type signal))" + vbCrLf
  Else
    DSNfile$ = DSNfile$ + "    (layer " + q + "2#Bottom" + q + " (type jumper))" + vbCrLf
  End If
  If TopLayer And BotLayer Then MultiLayer = True ' MultiLayer -  
  
  DSNfile$ = DSNfile$ + "    (boundary" + vbCrLf
  DSNfile$ = DSNfile$ + "      (rect pcb  0 0 " + Format2(PCBX)
  DSNfile$ = DSNfile$ + " " + Format2(PCBY) + ")" + vbCrLf
  DSNfile$ = DSNfile$ + "    )" + vbCrLf
  DSNfile$ = DSNfile$ + "    (boundary (path signal 0 "
  If BoundLine = 0 Then
    DSNfile$ = DSNfile$ + "0 0 0 " + Format2(PCBY) + " " + Format2(PCBX) + " " + Format2(PCBY) + " " + Format2(PCBX) + " 0"
  Else
    adr = BoundLine: DSNfile$ = DSNfile$ + objCoords(LayFile$, adr, 0, 0)
  End If
  DSNfile$ = DSNfile$ + "))" + vbCrLf
  
  DSNfile$ = DSNfile$ + "    (via" + vbCrLf
  DSNfile$ = DSNfile$ + "       " + q + "Square1206" + q + vbCrLf
  DSNfile$ = DSNfile$ + "    )" + vbCrLf
  '   
  DSNfile$ = DSNfile$ + "    (rule (width 0.35)(clearance 0.40))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.45 (type wire_pin)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.45 (type wire_smd)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.63 (type wire_via)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.20 (type pin_pin)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.63 (type pin_via)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.63 (type via_via)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.20 (type smd_pin)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.63 (type smd_via)))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (rule (clearance 0.20 (type smd_smd)))" + vbCrLf
  
  DSNfile$ = DSNfile$ + "    (control" + vbCrLf
  DSNfile$ = DSNfile$ + "      (via_at_smd on)" + vbCrLf
  DSNfile$ = DSNfile$ + "    )" + vbCrLf
  DSNfile$ = DSNfile$ + "  )" + vbCrLf

  DSNfile$ = DSNfile$ + "  (placement" + vbCrLf
  DSNfile$ = DSNfile$ + "    (place_control (flip_style rotate_first))" + vbCrLf
'
  '  :
  Image$ = "": Padstack$ = ""
  If Groups(0, 0) > 0 Then
    For i = 1 To Groups(0, 0)
      Form1.Label2.Caption = i
      '      
      For j = 0 To Nobj - 1
        If Groups(Groups(0, i), j) = 2 Or Groups(Groups(0, i), j) = 8 Then
          a$ = objName(LayFile$, objIndex(j))
          If a$ <> "" Then Exit For
        End If
      Next j
      a$ = q + Trim(Str$(i)) + "_" + a$ + q
      DSNfile$ = DSNfile$ + "    (component " + a$ + vbCrLf
      CorpName$ = q + "K" + Trim(Str$(i)) + q
      DSNfile$ = DSNfile$ + "      (place " + CorpName$ + " "
      ' ,    
      DSNfile$ = DSNfile$ + Format2(-Xcorp(i) / 100) + " " + Format2(-Ycorp(i) / 100) + " Front 0.00)" + vbCrLf
      DSNfile$ = DSNfile$ + "    )" + vbCrLf
      Image$ = Image$ + "    (image " + a$ + vbCrLf
      ' 
      For j = 0 To Nobj - 1
        If objLayer(LayFile$, objIndex(j)) <> "" Then
          Select Case Groups(Groups(0, i), j)
            Case 2 'PIN
              objCorpName(j) = CorpName$
              adr = objIndex(j) + 9: k = CLng(ReadFlt(LayFile$, adr) * 2) 'k -  
              k1 = Asc(Mid$(LayFile$, objIndex(j) + 24, 1)) 'k1 -  
              If k1 = 1 Then
                'a$ -: ,   
                a$ = q + "pin" + Trim(Str$(k)) + Chr$(Asc(Mid$(LayFile$, (objIndex(j) + 23), 1)) + 64 + (Asc(Mid$(LayFile$, (objIndex(j) + 58), 1))) * 7) + q
                Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(j + 1)) + q + " " + objCoord1(LayFile$, objIndex(j), Xcorp(i), Ycorp(i)) + ")" + vbCrLf
                If InStr(Padstack$, "(padstack " + a$) = 0 Then '     ,  
                  Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
                  Padstack$ = Padstack$ + "      (shape (circle " + objLayer(LayFile$, objIndex(j)) + " " + Format2(k / 100) + " 0 0))" + vbCrLf
                  Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
                  Padstack$ = Padstack$ + "    )" + vbCrLf
                End If
              Else
                a$ = q + "poly" + Trim(Str$(k1)) + "K" + Trim(Str$(j)) + q
                Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(j + 1)) + q + " " + objCoord1(LayFile$, objIndex(j), Xcorp(i), Ycorp(i)) + ")" + vbCrLf
                Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
                Call midCoord(LayFile$, objIndex(j), n, k1)
                Padstack$ = Padstack$ + "      (shape (polygon " + objLayer(LayFile$, objIndex(j)) + " 0.01 " + objCoords(LayFile$, objIndex(j), -n, -k1) + "))" + vbCrLf
                Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
                Padstack$ = Padstack$ + "    )" + vbCrLf
              End If
            Case 8 'SMD
              objCorpName(j) = CorpName$
              a$ = q + "smd" + smdID(LayFile$, objIndex(j)) + q
              Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(j + 1)) + q + " " + objCoord1(LayFile$, objIndex(j), Xcorp(i), Ycorp(i)) + ")" + vbCrLf
              If InStr(Padstack$, "(padstack " + a$) = 0 Then '     ,  
                Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
                Call midCoord(LayFile$, objIndex(j), n, k1)
                Padstack$ = Padstack$ + "      (shape (polygon " + objLayer(LayFile$, objIndex(j)) + " 0.01 " + objCoords(LayFile$, objIndex(j), -n, -k1) + "))" + vbCrLf
                Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
                Padstack$ = Padstack$ + "    )" + vbCrLf
              End If
          End Select
        End If
      Next j
      Image$ = Image$ + "    )" + vbCrLf
      DoEvents
    Next i
  End If
  '    
  For i = 0 To Nobj - 1
    k = Asc(Mid$(LayFile$, objIndex(i) + 1, 1))
    If (k = 2 Or k = 8) And objLayer(LayFile$, objIndex(i)) <> "" Then
      adr = objIndex(i) + 81
      j = ReadLng(LayFile$, adr): adr = adr + j  '   
      If ReadLng(LayFile$, adr) = 0 Then         '     
        Call midCoord(LayFile$, objIndex(i), objX, objY) '
        '
        a$ = q + "P" + Trim(Str$(i)) + "_" + objName(LayFile$, objIndex(i)) + q
        DSNfile$ = DSNfile$ + "    (component " + a$ + vbCrLf
        Select Case k
          Case 2
            objCorpName(i) = q + "V" + Trim(Str$(i)) + q
            DSNfile$ = DSNfile$ + "      (place " + objCorpName(i) + " "
            '
            DSNfile$ = DSNfile$ + Format2(objX / 100) + " " + Format2(objY / 100) + " Front 0.00)" + vbCrLf
            DSNfile$ = DSNfile$ + "    )" + vbCrLf
            Image$ = Image$ + "    (image " + a$ + vbCrLf
            adr = objIndex(i) + 9: k = CLng(ReadFlt(LayFile$, adr) * 2) 'k -  
            k1 = Asc(Mid$(LayFile$, objIndex(i) + 24, 1)) 'k1 -  
            If k1 = 1 Then
              'a$ -:  ,   
              a$ = q + "pin" + Trim(Str$(k)) + Chr$(Asc(Mid$(LayFile$, (objIndex(i) + 23), 1)) + 64 + (Asc(Mid$(LayFile$, (objIndex(i) + 58), 1))) * 7) + q
              Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(i + 1)) + q + " " + objCoord1(LayFile$, objIndex(i), -objX, -objY) + ")" + vbCrLf
              Image$ = Image$ + "    )" + vbCrLf
              If InStr(Padstack$, "(padstack " + a$) = 0 Then '     ,  
                Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
                Padstack$ = Padstack$ + "      (shape (circle " + objLayer(LayFile$, objIndex(i)) + " " + Format2(k / 100) + " 0 0))" + vbCrLf
                Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
                Padstack$ = Padstack$ + "    )" + vbCrLf
              End If
            Else
              a$ = q + "poly" + Trim(Str$(k1)) + "x" + Trim(Str$(i)) + q
              Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(i + 1)) + q + " " + objCoord1(LayFile$, objIndex(i), -objX, -objY) + ")" + vbCrLf
              Image$ = Image$ + "    )" + vbCrLf
              Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
              Padstack$ = Padstack$ + "      (shape (polygon " + objLayer(LayFile$, objIndex(i)) + " 0.01 " + objCoords(LayFile$, objIndex(i), -objX, -objY) + "))" + vbCrLf
              Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
              Padstack$ = Padstack$ + "    )" + vbCrLf
            End If
          Case 8
            objCorpName(i) = q + "S" + Trim(Str$(i)) + q
            DSNfile$ = DSNfile$ + "      (place " + objCorpName(i) + " "
            '
            DSNfile$ = DSNfile$ + Format2(objX / 100) + " " + Format2(objY / 100) + " Front 0.00)" + vbCrLf
            DSNfile$ = DSNfile$ + "    )" + vbCrLf
            Image$ = Image$ + "    (image " + a$ + vbCrLf
            a$ = q + "smdK" + Trim(Str$(i)) + q
            Image$ = Image$ + "      (pin " + a$ + " " + q + Trim(Str$(i + 1)) + q + " " + objCoord1(LayFile$, objIndex(i), -objX, -objY) + ")" + vbCrLf
            Image$ = Image$ + "    )" + vbCrLf
            Padstack$ = Padstack$ + "    (padstack " + a$ + vbCrLf
            Padstack$ = Padstack$ + "      (shape (polygon " + objLayer(LayFile$, objIndex(i)) + " 0.01 " + objCoords(LayFile$, objIndex(i), -objX, -objY) + "))" + vbCrLf
            Padstack$ = Padstack$ + "      (attach off)" + vbCrLf
            Padstack$ = Padstack$ + "    )" + vbCrLf
        End Select
      End If
    End If
  Next i
  DoEvents
  DSNfile$ = DSNfile$ + "  )" + vbCrLf

  DSNfile$ = DSNfile$ + "  (library" + vbCrLf
  DSNfile$ = DSNfile$ + Image$
' :
  If MultiLayer = False Then DSNfile$ = DSNfile$ + "    (jumper (length 3.56))" + vbCrLf
  DSNfile$ = DSNfile$ + "    (padstack " + q + "ViaDefault" + q + vbCrLf
  DSNfile$ = DSNfile$ + "      (shape (circle signal 1.53 0 0))" + vbCrLf
  DSNfile$ = DSNfile$ + "    )" + vbCrLf
  DSNfile$ = DSNfile$ + "    (padstack " + q + "Square1206" + q + vbCrLf
  DSNfile$ = DSNfile$ + "      (shape (rect " + q + "1#Top" + q + " -0.76 -0.76 0.76 0.76))" + vbCrLf
  DSNfile$ = DSNfile$ + "      (shape (rect " + q + "2#Bottom" + q + " -0.76 -0.76 0.76 0.76))" + vbCrLf
  DSNfile$ = DSNfile$ + "      (attach off)" + vbCrLf
  DSNfile$ = DSNfile$ + "    )" + vbCrLf
'   
  DSNfile$ = DSNfile$ + Padstack$
  DSNfile$ = DSNfile$ + "  )" + vbCrLf
' objCorpName(i)    ( ),     i

'  
  Form1.Label1.Caption = Form1.Label1.Caption + "     "
  DSNfile$ = DSNfile$ + "  (network" + vbCrLf
  Nnet = 1 ' 
  For i = 0 To Nobj - 1: grpIndex(i) = -1: Next i 'grpIndex -   
' 
  adr = grpIndex(Nobj) '   
  For i = 0 To Nobj - 1
    If Tree(LayFile$, objIndex, i, grpIndex(Nobj), Nnet, grpIndex) Then
      Form1.Label2.Caption = "Net$" + Trim(Str$(Nnet))
      Nnet = Nnet + 1
      DoEvents
    End If
  Next i
  '   
  For i = 0 To Nobj - 1
    k1 = Asc(Mid$(LayFile$, objIndex(i) + 23, 1)) ' 
    If k1 = 1 Or k1 = 3 Then  '  
      Select Case Asc(Mid$(LayFile$, objIndex(i) + 1, 1)) ' 
'        Case 4 '
'            grpIndex(i) = Nnet
'            Nnet = Nnet + 1
        Case 6 '
          ' 
          adr = objIndex(i) + 81
          n = ReadLng(LayFile$, adr): adr = adr + n
          n = ReadLng(LayFile$, adr): adr = adr + n * 4
          n = ReadLng(LayFile$, adr)
          objX = ReadFlt(LayFile$, adr)
          objY = ReadFlt(LayFile$, adr)
          adr = adr + (n - 2) * 8 '  
          n = objSearch(LayFile$, objX, objY, k1) 'n -   
          objX = ReadFlt(LayFile$, adr)
          objY = ReadFlt(LayFile$, adr)
          k = objSearch(LayFile$, objX, objY, k1) 'k -    
          '  
          If n >= 0 And k < 0 Then
            If grpIndex(n) >= 0 Then
              grpIndex(i) = grpIndex(n)
            Else
              grpIndex(i) = Nnet
              grpIndex(n) = grpIndex(i)
              Nnet = Nnet + 1
            End If
          End If
          If n < 0 And k >= 0 Then
            If grpIndex(k) >= 0 Then
              grpIndex(i) = grpIndex(k)
            Else
              grpIndex(i) = Nnet
              grpIndex(k) = grpIndex(i)
              Nnet = Nnet + 1
            End If
          End If
          '  
          If n >= 0 And k >= 0 Then
            If grpIndex(n) < 0 And grpIndex(k) < 0 Then
              grpIndex(i) = Nnet
              grpIndex(n) = grpIndex(i)
              grpIndex(k) = grpIndex(i)
              Nnet = Nnet + 1
            End If
            If grpIndex(n) >= 0 And grpIndex(k) < 0 Then
              grpIndex(i) = grpIndex(n)
              grpIndex(k) = grpIndex(n)
            End If
            If grpIndex(n) < 0 And grpIndex(k) >= 0 Then
              grpIndex(i) = grpIndex(k)
              grpIndex(n) = grpIndex(k)
            End If
            If grpIndex(n) >= 0 And grpIndex(k) >= 0 Then
              If grpIndex(n) = grpIndex(k) Then
                grpIndex(i) = grpIndex(n)
              Else '     .
                If grpIndex(n) < grpIndex(k) Then
                  grpIndex(i) = grpIndex(n)
                  n = grpIndex(n): k = grpIndex(k)
                Else
                  grpIndex(i) = grpIndex(k)
                  k1 = k: k = grpIndex(n): n = grpIndex(k1)
                  ' n  
                End If
                For j = 0 To Nobj - 1 '  .
                  If grpIndex(j) = k Then grpIndex(j) = n
                  If grpIndex(j) > k Then grpIndex(j) = grpIndex(j) - 1
                Next j
                Nnet = Nnet - 1
              End If
            End If
          End If
          Form1.Label2.Caption = "Net$" + Trim(Str$(Nnet - 1))
          DoEvents
      End Select
    End If
  Next i
  Nnet = Nnet - 1
  ' grpIndex(i)      i
  'Nnet - 
'  
  If Nnet > 0 Then
    For i = 1 To Nnet 'i - 
      DSNfile$ = DSNfile$ + "    (net " + q + "Net$" + Trim(Str$(i)) + q + vbCrLf
      DSNfile$ = DSNfile$ + "      (pins"
      For j = 0 To Nobj - 1
        If grpIndex(j) = i And objCorpName(j) <> "" Then 'j -
          DSNfile$ = DSNfile$ + " " + objCorpName(j) + "-" + q + Trim(Str$(j + 1)) + q
        End If
      Next j
      DSNfile$ = DSNfile$ + ")" + vbCrLf
      DSNfile$ = DSNfile$ + "    )" + vbCrLf
      DoEvents
    Next i
  End If
  DSNfile$ = DSNfile$ + "  )" + vbCrLf

'   
  
  Form1.Label1.Caption = "     "
  DSNfile$ = DSNfile$ + "  (wiring" + vbCrLf
  For i = 0 To Nobj - 1
    Form1.Label2.Caption = i
    a$ = objLayer(LayFile$, objIndex(i)) '
    If a$ <> "" Then
      adr = objIndex(i) + 17: j = ReadLng(LayFile$, adr) / 100 '
      Select Case Asc(Mid$(LayFile$, (objIndex(i) + 1), 1))
      ' 
        Case 6  '
          DSNfile$ = DSNfile$ + "    (wire" + vbCrLf
          DSNfile$ = DSNfile$ + "      (path " + a$ + " " + Format2(j) + " " + objCoords(LayFile$, objIndex(i), 0, 0) + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "      (type protect)" + vbCrLf
          If grpIndex(i) < 0 Then a$ = "$dummy" Else a$ = "Net$" + Trim(Str$(grpIndex(i)))
          DSNfile$ = DSNfile$ + "      (net " + q + a$ + q + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "    )" + vbCrLf
        Case 4  '
          DSNfile$ = DSNfile$ + "    (wire" + vbCrLf
          DSNfile$ = DSNfile$ + "      (poly " + a$ + " " + Format2(j) + " " + objCoords(LayFile$, objIndex(i), 0, 0) + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "      (net " + q + "$dummy" + q + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "    )" + vbCrLf
        Case 5  '
          adr = objIndex(i) + 9
          j = ReadFlt(LayFile$, adr)
          j = (j - ReadFlt(LayFile$, adr)) / 100 ' 
          DSNfile$ = DSNfile$ + "    (wire" + vbCrLf
          DSNfile$ = DSNfile$ + "      (path " + a$ + " " + Format2(j) + " " + objCoords(LayFile$, objIndex(i), 0, 0) + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "      (net " + q + "$dummy" + q + ")" + vbCrLf
          DSNfile$ = DSNfile$ + "    )" + vbCrLf
      End Select
    End If
    DoEvents
  Next i
  DSNfile$ = DSNfile$ + "  )" + vbCrLf
  DSNfile$ = DSNfile$ + ")" + vbCrLf
  Form1.Label1.Caption = ""
  Form1.Label2.Caption = ""
End Function

